=== fmcdaq2/kcu105/Makefile ===
## Makefile

include ../../scripts/noos.mk

M_HDF_FILE := $(HDL-DIR)/projects/daq2/kcu105/daq2_kcu105.sdk/system_top.hdf

include $(NOOS-DIR)/fmcdaq2/fmcdaq2.mk
include $(NOOS-DIR)/scripts/microblaze.mk
