=== host/common/test/CMakeLists.txt ===
add_subdirectory(dc_calibration)
