=== debian/changelog ===
bladerf (0.2021.10-2) unstable; urgency=medium

  * source-only upload to allow migration

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 07 Dec 2021 19:47:41 -0500

bladerf (0.2021.10-1) unstable; urgency=medium

  * New upstream release
  * update adds xA05 support (Closes: #999864)
    (adds new bladerf-fpga-hostedxa5 contrib package)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 20 Nov 2021 13:12:07 -0500

bladerf (0.2021.03-1) experimental; urgency=medium

  * New upstream release
  * update to 2021.03-4-g29455d29

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 04 Jul 2021 17:54:29 -0400

bladerf (0.2021.03~upstream-1) unstable; urgency=low

  * Release for 2021.03 tag
  * Added packet mode format BLADERF_FORMAT_PACKET_META. libbladeRF is able to
  * exchange variable length packets with the HDL if packet mode is enabled
  * Added RFIC parameters for burst waveforms
  * Ability to query backend for handle and lock
  * Variable length packet support for PACKET_META mode
  * Indicate presence of packet cores in FPGA
  * Add packet mode. The HDL fabric is able to exchange variable length
  * packets with the host
  * Added packet_generator as an example for how to send packets to the host
  * Added bladeRF 2.0 micro headless example variant "foxhunt"
  * Fix metadata related arithmetic and logic

 -- Robert Ghilduta (Nuand LLC) <robert.ghilduta@nuand.com>  Tue, 16 Feb 2021 00:50:56 -0500
